      program host
c     A demonstration program to calculate the temperature distribution
c     in a rectangle with imposed temperatures at the sides.
c     Assume that the points are equally spaced.
c
c               j->     T1
c              ____________________
c      ^       |                  |    
c      k    T2 |                  | T4
c              |__________________|
c                       T3
c
      include 'para.h'

      integer ids(maxsplit),jds(maxsplit),kds(maxsplit)
      integer size
      integer*4 info(nodemax,8)
      integer*4 APPLPID,HOSTPID,INFOTYPE,DONETYPE
      integer*4 CUBESIZE,ALLNODES 
      real*4 resid
      infosize = nodemax*4*8


      data   APPLPID  /0/,
     .       HOSTPID  /100/,
     .	     CUBESIZE /4/,
     .	     ALLNODES /-1/,
     .       INFOTYPE /1/,
     .       DONETYPE /2/

      call setpid(HOSTPID)
      write(*,*) 'host is loading nodes'
      call load('node',ALLNODES,APPLPID)

      size = numnodes()

      write(*,*) 'available nodes = ',size
c     Call the routine which determines how the domain will be broken up.
c     This returns a revised number of nodes, and the size grid for each.
      call breakit(1,jdhost,kdhost,size,ids,
     .		   jds,kds,idiv,jdiv,kdiv,maxsplit)
      write(*,*) 'using size = ',idiv*jdiv*kdiv

c     Determine the starting and ending parameters for each node's
c     portion of the grid, and connectivity information.
      call split(jds,kds,jdiv,kdiv,info,nodemax)

      call htocl(info,nodemax*8)
      call csend(INFOTYPE, info, INFOSIZE, ALLNODES, APPLPID)

      call crecv(DONETYPE, resid, iprec)
      call ctohf(resid,1)

      if (resid.lt.0.0) then
	write(*,*) 'Node sent stop message!'
      else
        write(*,*) 'Done!, got back resid = ',resid
      end if
      write(*,*) 'Cleaning...'
      call killcube(ALLNODES,APPLPID)
      write(*,*) 'Stopping.'
      stop
      end


      subroutine split(jds,kds,jdiv,kdiv,A,nodemax)
      dimension jds(jdiv),kds(kdiv)
      integer*4 A(nodemax,8)
      n  = 0
      kcor=1
      do 1 k = 1,kdiv
        jcor=1
	do 2 j = 1,jdiv
	  n = n + 1
	  A(n,1) = jds(j)
	  A(n,2) = kds(k)
	  do 3 i = 3,6
3           A(n,i) = 0
	  if (j.gt.   1) A(n,3) = n-1
	  if (j.lt.jdiv) A(n,4) = n+1
	  if (k.gt.   1) A(n,5) = n-jdiv
	  if (k.lt.kdiv) A(n,6) = n+jdiv
	  A(n,7) = jcor
	  A(n,8) = kcor
          jcor=jcor+jds(j)-2
2       continue
        kcor=kcor+kds(k)-2
1       continue
        return
	end


